/*
 * Semaforo.cpp
 *
 *  Created on: 5 de Set de 2018
 *      Author: escarvalho
 */

#include "Semaforo.h"

namespace std {

	Semaforo::Semaforo() {
		// Criao das 3 lmpadas
		vLampada.push_back(Lampada());
		(*itLampada).setCorAtiva(Lampada::verde);
		vLampada.push_back(Lampada());
		(*itLampada).setCorAtiva(Lampada::vermelho);
		vLampada.push_back(Lampada());
		(*itLampada).setCorAtiva(Lampada::amarelo);
	}

    vector<Lampada>::iterator Semaforo::getItLampada() const
    {
        return itLampada;
    }

    vector<Lampada> Semaforo::getLampada() const
    {
        return vLampada;
    }

    bool Semaforo::isStatusOnOff() const
    {
        return statusOnOff;
    }

    void Semaforo::setItLampada(vector<Lampada>::iterator itLampada)
    {
        this->itLampada = itLampada;
    }

    void Semaforo::setLampada(vector<Lampada> vLampada)
    {
        this->vLampada = vLampada;
    }

    void Semaforo::setStatusOnOff(bool statusOnOff)
    {
        this->statusOnOff = statusOnOff;

    }

	Semaforo::~Semaforo() {
		// TODO Auto-generated destructor stub
	}

    bool Semaforo::temporiza(Lampada::Cor cor)
    {
    	int start = clock();
    	double diff;
    	double limite;

    	// Apaga as lmpadas
    	vLampada.at(1).setStatusOnOff(false);
    	vLampada.at(2).setStatusOnOff(false);
    	vLampada.at(3).setStatusOnOff(false);

    	// Verifica a cor atual do semforo
    	switch(cor)
    	{
			case Lampada::vermelho:
				limite = 30.0;
				vLampada.at(2).setStatusOnOff(true);
				break;
			case Lampada::verde:
				limite = 25.0;
				vLampada.at(1).setStatusOnOff(true);
				break;
			case Lampada::amarelo:
				limite = 5.0;
				vLampada.at(3).setStatusOnOff(true);
				break;
    	}

    	// Temporiza
    	do
    	{
    	  diff = (clock()-start)/(double)(CLOCKS_PER_SEC);
    	} while (diff < limite);

    	return true;
    }

    void Semaforo::alternaCor()
    {
    	temporiza(Lampada::verde);
    	temporiza(Lampada::amarelo);
    	temporiza(Lampada::vermelho);
    }

} /* namespace std */
